Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageReslice Class Reference

`#include <vtkImageReslice.h>`

Inheritance diagram for vtkImageReslice:

[legend]
Collaboration diagram for vtkImageReslice:

[legend]
List of all members.

## Detailed Description

Reslices a volume along a new set of axes.

Date:
  2002/12/11 14:26:22

Revision:
  1.10

vtkImageReslice is the swiss-army-knife of image geometry filters: It can permute, rotate, flip, scale, resample, deform, and pad image data in any combination with reasonably high efficiency. Simple operations such as permutation, resampling and padding are done with similar efficiently to the specialized vtkImagePermute, vtkImageResample, and vtkImagePad filters. There are a number of tasks that vtkImageReslice is well suited for:

1) Application of simple rotations, scales, and translations to an image. It is often a good idea to use vtkImageChangeInformation to center the image first, so that scales and rotations occur around the center rather than around the lower-left corner of the image.

2) Resampling of one data set to match the voxel sampling of a second data set via the SetInformationInput() method, e.g. for the purpose of comparing two images or combining two images. A transformation, either linear or nonlinear, can be applied at the same time via the SetResliceTransform method if the two images are not in the same coordinate space.

3) Extraction of slices from an image volume. The most convenient way to do this is to use SetResliceAxesDirectionCosines() to specify the orientation of the slice. The direction cosines give the x, y, and z axes for the output volume. The method SetOutputDimensionality(2) is used to specify that want to output a slice rather than a volume. The SetResliceAxesOrigin() command is used to provide an (x,y,z) point that the slice will pass through. You can use both the ResliceAxes and the ResliceTransform at the same time, in order to extract slices from a volume that you have applied a transformation to.

Warning:
  This filter is very inefficient if the output X dimension is 1.

See also:
  vtkAbstractTransform vtkMatrix4x4

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (97%)

CVS logs (CVSweb):
  - .`h` (`/Imaging/vtkImageReslice.h)`
  - .`cxx` (`/Imaging/vtkImageReslice.cxx)`

Tests:
  vtkImageReslice (Tests)

Definition at line 84 of file vtkImageReslice.h.

## Public Types
typedef vtkImageToImageFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
virtual void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long int | GetMTime ()
virtual void | SetResliceAxes (vtkMatrix4x4 *)
virtual vtkMatrix4x4 * | GetResliceAxes ()
void | SetResliceAxesDirectionCosines (double x0, double x1, double x2, double y0, double y1, double y2, double z0, double z1, double z2)
void | SetResliceAxesDirectionCosines (const double x[3], const double y[3], const double z[3])
void | SetResliceAxesDirectionCosines (const double xyz[9])
void | GetResliceAxesDirectionCosines (double x[3], double y[3], double z[3])
void | GetResliceAxesDirectionCosines (double xyz[9])
double * | GetResliceAxesDirectionCosines ()
void | SetResliceAxesOrigin (double x, double y, double z)
void | SetResliceAxesOrigin (const double xyz[3])
void | GetResliceAxesOrigin (double xyz[3])
double * | GetResliceAxesOrigin ()
virtual void | SetResliceTransform (vtkAbstractTransform *)
virtual vtkAbstractTransform * | GetResliceTransform ()
virtual void | SetInformationInput (vtkImageData *)
virtual vtkImageData * | GetInformationInput ()
virtual void | SetTransformInputSampling (int)
virtual void | TransformInputSamplingOn ()
virtual void | TransformInputSamplingOff ()
virtual int | GetTransformInputSampling ()
virtual void | SetAutoCropOutput (int)
virtual void | AutoCropOutputOn ()
virtual void | AutoCropOutputOff ()
virtual int | GetAutoCropOutput ()
virtual void | SetWrap (int)
virtual int | GetWrap ()
virtual void | WrapOn ()
virtual void | WrapOff ()
virtual void | SetMirror (int)
virtual int | GetMirror ()
virtual void | MirrorOn ()
virtual void | MirrorOff ()
virtual void | SetInterpolationMode (int)
virtual int | GetInterpolationMode ()
void | SetInterpolationModeToNearestNeighbor ()
void | SetInterpolationModeToLinear ()
void | SetInterpolationModeToCubic ()
const char * | GetInterpolationModeAsString ()
virtual void | SetOptimization (int)
virtual int | GetOptimization ()
virtual void | OptimizationOn ()
virtual void | OptimizationOff ()
virtual void | SetBackgroundColor (float, float, float, float)
virtual void | SetBackgroundColor (float[4])
virtual float * | GetBackgroundColor ()
virtual void | GetBackgroundColor (float &, float &, float &, float &)
virtual void | GetBackgroundColor (float[4])
void | SetBackgroundLevel (float v)
float | GetBackgroundLevel ()
virtual void | SetOutputSpacing (float, float, float)
virtual void | SetOutputSpacing (float[3])
virtual float * | GetOutputSpacing ()
virtual void | GetOutputSpacing (float &, float &, float &)
virtual void | GetOutputSpacing (float[3])
void | SetOutputSpacingToDefault ()
virtual void | SetOutputOrigin (float, float, float)
virtual void | SetOutputOrigin (float[3])
virtual float * | GetOutputOrigin ()
virtual void | GetOutputOrigin (float &, float &, float &)
virtual void | GetOutputOrigin (float[3])
void | SetOutputOriginToDefault ()
virtual void | SetOutputExtent (int, int, int, int, int, int)
virtual void | SetOutputExtent (int[6])
virtual int * | GetOutputExtent ()
virtual void | GetOutputExtent (int &, int &, int &, int &, int &, int &)
virtual void | GetOutputExtent (int[6])
void | SetOutputExtentToDefault ()
virtual void | SetOutputDimensionality (int)
virtual int | GetOutputDimensionality ()
void | SetInterpolate (int t)
void | InterpolateOn ()
void | InterpolateOff ()
int | GetInterpolate ()
void | SetStencil (vtkImageStencilData *stencil)
vtkImageStencilData * | GetStencil ()
## Static Public Methods
vtkImageReslice * | New ()
int | IsTypeOf (const char *type)
vtkImageReslice * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImageReslice ()
| ~vtkImageReslice ()
void | GetAutoCroppedOutputBounds (vtkImageData *input, float bounds[6])
void | ExecuteInformation (vtkImageData *input, vtkImageData *output)
void | ExecuteInformation ()
void | ComputeInputUpdateExtents (vtkDataObject *output)
void | ComputeInputUpdateExtent (int inExt[6], int outExt[6])
void | ThreadedExecute (vtkImageData *inData, vtkImageData *outData, int ext[6], int id)
vtkMatrix4x4 * | GetIndexMatrix ()
vtkAbstractTransform * | GetOptimizedTransform ()
void | OptimizedComputeInputUpdateExtent (int inExt[6], int outExt[6])
void | OptimizedThreadedExecute (vtkImageData *inData, vtkImageData *outData, int ext[6], int id)
## Protected Attributes
vtkMatrix4x4 * | ResliceAxes
double | ResliceAxesDirectionCosines [9]
double | ResliceAxesOrigin [3]
vtkAbstractTransform * | ResliceTransform
vtkImageData * | InformationInput
int | Wrap
int | Mirror
int | InterpolationMode
int | Optimization
float | BackgroundColor [4]
float | OutputOrigin [3]
float | OutputSpacing [3]
int | OutputExtent [6]
int | OutputDimensionality
int | TransformInputSampling
int | AutoCropOutput
vtkMatrix4x4 * | IndexMatrix
vtkAbstractTransform * | OptimizedTransform

## Member Typedef Documentation

typedef vtkImageToImageFilter vtkImageReslice::Superclass

| Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample. Definition at line 88 of file vtkImageReslice.h.

## Constructor & Destructor Documentation

vtkImageReslice::vtkImageReslice | ( |  | ) | `[protected]`

vtkImageReslice::~vtkImageReslice | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageReslice* vtkImageReslice::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

virtual const char* vtkImageReslice::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

int vtkImageReslice::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

virtual int vtkImageReslice::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

vtkImageReslice* vtkImageReslice::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

virtual void vtkImageReslice::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, vtkImagePermute, and vtkImageResample.

virtual void vtkImageReslice::SetResliceAxes | ( | vtkMatrix4x4 * |  | ) | `[virtual]`

| This method is used to set up the axes for the output voxels. The output Spacing, Origin, and Extent specify the locations of the voxels within the coordinate system defined by the axes. The ResliceAxes are used most often to permute the data, e.g. to extract ZY or XZ slices of a volume as 2D XY images. The first column of the matrix specifies the x-axis vector (the fourth element must be set to zero), the second column specifies the y-axis, and the third column the z-axis. The fourth column is the origin of the axes (the fourth element must be set to one). An alternative to SetResliceAxes() is to use SetResliceAxesDirectionCosines() to set the directions of the axes and SetResliceAxesOrigin() to set the origin of the axes.

virtual vtkMatrix4x4* vtkImageReslice::GetResliceAxes | ( |  | ) | `[virtual]`

| This method is used to set up the axes for the output voxels. The output Spacing, Origin, and Extent specify the locations of the voxels within the coordinate system defined by the axes. The ResliceAxes are used most often to permute the data, e.g. to extract ZY or XZ slices of a volume as 2D XY images. The first column of the matrix specifies the x-axis vector (the fourth element must be set to zero), the second column specifies the y-axis, and the third column the z-axis. The fourth column is the origin of the axes (the fourth element must be set to one). An alternative to SetResliceAxes() is to use SetResliceAxesDirectionCosines() to set the directions of the axes and SetResliceAxesOrigin() to set the origin of the axes.

void vtkImageReslice::SetResliceAxesDirectionCosines | ( | double | x0,
|  | double | x1,
|  | double | x2,
|  | double | y0,
|  | double | y1,
|  | double | y2,
|  | double | z0,
|  | double | z1,
|  | double | z2
| ) |

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists.

void vtkImageReslice::SetResliceAxesDirectionCosines | ( | const double | x[3],
|  | const double | y[3],
|  | const double | z[3]
| ) | `[inline]`

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists. Definition at line 117 of file vtkImageReslice.h.

void vtkImageReslice::SetResliceAxesDirectionCosines | ( | const double | xyz[9] | ) | `[inline]`

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists. Definition at line 123 of file vtkImageReslice.h.

void vtkImageReslice::GetResliceAxesDirectionCosines | ( | double | x[3],
|  | double | y[3],
|  | double | z[3]
| ) |

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists.

void vtkImageReslice::GetResliceAxesDirectionCosines | ( | double | xyz[9] | ) | `[inline]`

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists. Definition at line 128 of file vtkImageReslice.h.

double* vtkImageReslice::GetResliceAxesDirectionCosines | ( |  | ) | `[inline]`

| Specify the direction cosines for the ResliceAxes (i.e. the first three elements of each of the first three columns of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create a new matrix if none exists. Definition at line 130 of file vtkImageReslice.h.

void vtkImageReslice::SetResliceAxesOrigin | ( | double | x,
|  | double | y,
|  | double | z
| ) |

| Specify the origin for the ResliceAxes (i.e. the first three elements of the final column of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create new matrix if none exists.

void vtkImageReslice::SetResliceAxesOrigin | ( | const double | xyz[3] | ) | `[inline]`

| Specify the origin for the ResliceAxes (i.e. the first three elements of the final column of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create new matrix if none exists. Definition at line 140 of file vtkImageReslice.h.

void vtkImageReslice::GetResliceAxesOrigin | ( | double | xyz[3] | ) |

| Specify the origin for the ResliceAxes (i.e. the first three elements of the final column of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create new matrix if none exists.

double* vtkImageReslice::GetResliceAxesOrigin | ( |  | ) | `[inline]`

| Specify the origin for the ResliceAxes (i.e. the first three elements of the final column of the ResliceAxes matrix). This will modify the current ResliceAxes matrix, or create new matrix if none exists. Definition at line 143 of file vtkImageReslice.h.

virtual void vtkImageReslice::SetResliceTransform | ( | vtkAbstractTransform * |  | ) | `[virtual]`

| Set a transform to be applied to the resampling grid that has been defined via the ResliceAxes and the output Origin, Spacing and Extent. Note that applying a transform to the resampling grid (which lies in the output coordinate system) is equivalent to applying the inverse of that transform to the input volume. Nonlinear transforms such as vtkGridTransform and vtkThinPlateSplineTransform can be used here.

virtual vtkAbstractTransform* vtkImageReslice::GetResliceTransform | ( |  | ) | `[virtual]`

| Set a transform to be applied to the resampling grid that has been defined via the ResliceAxes and the output Origin, Spacing and Extent. Note that applying a transform to the resampling grid (which lies in the output coordinate system) is equivalent to applying the inverse of that transform to the input volume. Nonlinear transforms such as vtkGridTransform and vtkThinPlateSplineTransform can be used here.

virtual void vtkImageReslice::SetInformationInput | ( | vtkImageData * |  | ) | `[virtual]`

| Set a vtkImageData from which the default Spacing, Origin, and WholeExtent of the output will be copied. The spacing, origin, and extent will be permuted according to the ResliceAxes. Any values set via SetOutputSpacing, SetOutputOrigin, and SetOutputExtent will override these values. By default, the Spacing, Origin, and WholeExtent of the Input are used.

virtual vtkImageData* vtkImageReslice::GetInformationInput | ( |  | ) | `[virtual]`

| Set a vtkImageData from which the default Spacing, Origin, and WholeExtent of the output will be copied. The spacing, origin, and extent will be permuted according to the ResliceAxes. Any values set via SetOutputSpacing, SetOutputOrigin, and SetOutputExtent will override these values. By default, the Spacing, Origin, and WholeExtent of the Input are used.

virtual void vtkImageReslice::SetTransformInputSampling | ( | int |  | ) | `[virtual]`

| Specify whether to transform the spacing, origin and extent of the Input (or the InformationInput) according to the direction cosines and origin of the ResliceAxes before applying them as the default output spacing, origin and extent. Default: On.

virtual void vtkImageReslice::TransformInputSamplingOn | ( |  | ) | `[virtual]`

| Specify whether to transform the spacing, origin and extent of the Input (or the InformationInput) according to the direction cosines and origin of the ResliceAxes before applying them as the default output spacing, origin and extent. Default: On.

virtual void vtkImageReslice::TransformInputSamplingOff | ( |  | ) | `[virtual]`

| Specify whether to transform the spacing, origin and extent of the Input (or the InformationInput) according to the direction cosines and origin of the ResliceAxes before applying them as the default output spacing, origin and extent. Default: On.

virtual int vtkImageReslice::GetTransformInputSampling | ( |  | ) | `[virtual]`

| Specify whether to transform the spacing, origin and extent of the Input (or the InformationInput) according to the direction cosines and origin of the ResliceAxes before applying them as the default output spacing, origin and extent. Default: On.

virtual void vtkImageReslice::SetAutoCropOutput | ( | int |  | ) | `[virtual]`

| Turn this on if you want to guarantee that the extent of the output will be large enough to ensure that none of the data will be cropped.

virtual void vtkImageReslice::AutoCropOutputOn | ( |  | ) | `[virtual]`

| Turn this on if you want to guarantee that the extent of the output will be large enough to ensure that none of the data will be cropped.

virtual void vtkImageReslice::AutoCropOutputOff | ( |  | ) | `[virtual]`

| Turn this on if you want to guarantee that the extent of the output will be large enough to ensure that none of the data will be cropped.

virtual int vtkImageReslice::GetAutoCropOutput | ( |  | ) | `[virtual]`

| Turn this on if you want to guarantee that the extent of the output will be large enough to ensure that none of the data will be cropped.

virtual void vtkImageReslice::SetWrap | ( | int |  | ) | `[virtual]`

| Turn on wrap-pad feature (default: off).

virtual int vtkImageReslice::GetWrap | ( |  | ) | `[virtual]`

| Turn on wrap-pad feature (default: off).

virtual void vtkImageReslice::WrapOn | ( |  | ) | `[virtual]`

| Turn on wrap-pad feature (default: off).

virtual void vtkImageReslice::WrapOff | ( |  | ) | `[virtual]`

| Turn on wrap-pad feature (default: off).

virtual void vtkImageReslice::SetMirror | ( | int |  | ) | `[virtual]`

| Turn on mirror-pad feature (default: off). This will override the wrap-pad.

virtual int vtkImageReslice::GetMirror | ( |  | ) | `[virtual]`

| Turn on mirror-pad feature (default: off). This will override the wrap-pad.

virtual void vtkImageReslice::MirrorOn | ( |  | ) | `[virtual]`

| Turn on mirror-pad feature (default: off). This will override the wrap-pad.

virtual void vtkImageReslice::MirrorOff | ( |  | ) | `[virtual]`

| Turn on mirror-pad feature (default: off). This will override the wrap-pad.

virtual void vtkImageReslice::SetInterpolationMode | ( | int |  | ) | `[virtual]`

| Set interpolation mode (default: nearest neighbor).

virtual int vtkImageReslice::GetInterpolationMode | ( |  | ) | `[virtual]`

| Set interpolation mode (default: nearest neighbor).

void vtkImageReslice::SetInterpolationModeToNearestNeighbor | ( |  | ) | `[inline]`

| Set interpolation mode (default: nearest neighbor). Definition at line 208 of file vtkImageReslice.h. References VTK_RESLICE_NEAREST.

void vtkImageReslice::SetInterpolationModeToLinear | ( |  | ) | `[inline]`

| Set interpolation mode (default: nearest neighbor). Definition at line 210 of file vtkImageReslice.h. References VTK_RESLICE_LINEAR.

void vtkImageReslice::SetInterpolationModeToCubic | ( |  | ) | `[inline]`

| Set interpolation mode (default: nearest neighbor). Definition at line 212 of file vtkImageReslice.h. References VTK_RESLICE_CUBIC.

const char * vtkImageReslice::GetInterpolationModeAsString | ( |  | ) | `[inline]`

| Set interpolation mode (default: nearest neighbor). Definition at line 352 of file vtkImageReslice.h. References InterpolationMode, VTK_RESLICE_CUBIC, VTK_RESLICE_LINEAR, and VTK_RESLICE_NEAREST.

virtual void vtkImageReslice::SetOptimization | ( | int |  | ) | `[virtual]`

| Turn on and off optimizations (default on, they should only be turned off for testing purposes).

virtual int vtkImageReslice::GetOptimization | ( |  | ) | `[virtual]`

| Turn on and off optimizations (default on, they should only be turned off for testing purposes).

virtual void vtkImageReslice::OptimizationOn | ( |  | ) | `[virtual]`

| Turn on and off optimizations (default on, they should only be turned off for testing purposes).

virtual void vtkImageReslice::OptimizationOff | ( |  | ) | `[virtual]`

| Turn on and off optimizations (default on, they should only be turned off for testing purposes).

virtual void vtkImageReslice::SetBackgroundColor | ( | float | ,
|  | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the background color (for multi-component images).

virtual void vtkImageReslice::SetBackgroundColor | ( | float | [4] | ) | `[virtual]`

| Set the background color (for multi-component images).

virtual float* vtkImageReslice::GetBackgroundColor | ( |  | ) | `[virtual]`

| Set the background color (for multi-component images).

virtual void vtkImageReslice::GetBackgroundColor | ( | float & | ,
|  | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set the background color (for multi-component images).

virtual void vtkImageReslice::GetBackgroundColor | ( | float | [4] | ) | `[virtual]`

| Set the background color (for multi-component images).

void vtkImageReslice::SetBackgroundLevel | ( | float | v | ) | `[inline]`

| Set background grey level (for single-component images). Definition at line 233 of file vtkImageReslice.h.

float vtkImageReslice::GetBackgroundLevel | ( |  | ) | `[inline]`

| Set background grey level (for single-component images). Definition at line 234 of file vtkImageReslice.h.

virtual void vtkImageReslice::SetOutputSpacing | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes.

virtual void vtkImageReslice::SetOutputSpacing | ( | float | [3] | ) | `[virtual]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes.

virtual float* vtkImageReslice::GetOutputSpacing | ( |  | ) | `[virtual]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputSpacing | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputSpacing | ( | float | [3] | ) | `[virtual]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes.

void vtkImageReslice::SetOutputSpacingToDefault | ( |  | ) | `[inline]`

| Set the voxel spacing for the output data. The default output spacing is the input spacing permuted through the ResliceAxes. Definition at line 242 of file vtkImageReslice.h. References VTK_FLOAT_MAX.

virtual void vtkImageReslice::SetOutputOrigin | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes.

virtual void vtkImageReslice::SetOutputOrigin | ( | float | [3] | ) | `[virtual]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes.

virtual float* vtkImageReslice::GetOutputOrigin | ( |  | ) | `[virtual]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputOrigin | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputOrigin | ( | float | [3] | ) | `[virtual]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes.

void vtkImageReslice::SetOutputOriginToDefault | ( |  | ) | `[inline]`

| Set the origin for the output data. The default output origin is the input origin permuted through the ResliceAxes. Definition at line 251 of file vtkImageReslice.h. References VTK_FLOAT_MAX.

virtual void vtkImageReslice::SetOutputExtent | ( | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) | `[virtual]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes.

virtual void vtkImageReslice::SetOutputExtent | ( | int | [6] | ) | `[virtual]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes.

virtual int* vtkImageReslice::GetOutputExtent | ( |  | ) | `[virtual]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputExtent | ( | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & |
| ) | `[virtual]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes.

virtual void vtkImageReslice::GetOutputExtent | ( | int | [6] | ) | `[virtual]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes.

void vtkImageReslice::SetOutputExtentToDefault | ( |  | ) | `[inline]`

| Set the extent for the output data. The default output extent is the input extent permuted through the ResliceAxes. Definition at line 260 of file vtkImageReslice.h. References VTK_INT_MAX, and VTK_INT_MIN.

virtual void vtkImageReslice::SetOutputDimensionality | ( | int |  | ) | `[virtual]`

| Force the dimensionality of the output to either 1, 2, 3 or 0 (default: 3). If the dimensionality is 2D, then the Z extent of the output is forced to (0,0) and the Z origin of the output is forced to 0.0 (i.e. the output extent is confined to the xy plane). If the dimensionality is 1D, the output extent is confined to the x axis. For 0D, the output extent consists of a single voxel at (0,0,0).

virtual int vtkImageReslice::GetOutputDimensionality | ( |  | ) | `[virtual]`

| Force the dimensionality of the output to either 1, 2, 3 or 0 (default: 3). If the dimensionality is 2D, then the Z extent of the output is forced to (0,0) and the Z origin of the output is forced to 0.0 (i.e. the output extent is confined to the xy plane). If the dimensionality is 1D, the output extent is confined to the x axis. For 0D, the output extent consists of a single voxel at (0,0,0).

unsigned long int vtkImageReslice::GetMTime | ( |  | ) | `[virtual]`

| When determining the modified time of the filter, this check the modified time of the transform and matrix. Reimplemented from vtkObject.

void vtkImageReslice::SetInterpolate | ( | int | t | ) | `[inline]`

| Convenient methods for switching between nearest-neighbor and linear interpolation. InterpolateOn() is equivalent to SetInterpolationModeToLinear() and InterpolateOff() is equivalent to SetInterpolationModeToNearestNeighbor(). You should not use these methods if you use the SetInterpolationMode methods. Definition at line 287 of file vtkImageReslice.h.

void vtkImageReslice::InterpolateOn | ( |  | ) | `[inline]`

| Convenient methods for switching between nearest-neighbor and linear interpolation. InterpolateOn() is equivalent to SetInterpolationModeToLinear() and InterpolateOff() is equivalent to SetInterpolationModeToNearestNeighbor(). You should not use these methods if you use the SetInterpolationMode methods. Definition at line 292 of file vtkImageReslice.h.

void vtkImageReslice::InterpolateOff | ( |  | ) | `[inline]`

| Convenient methods for switching between nearest-neighbor and linear interpolation. InterpolateOn() is equivalent to SetInterpolationModeToLinear() and InterpolateOff() is equivalent to SetInterpolationModeToNearestNeighbor(). You should not use these methods if you use the SetInterpolationMode methods. Definition at line 294 of file vtkImageReslice.h.

int vtkImageReslice::GetInterpolate | ( |  | ) | `[inline]`

| Convenient methods for switching between nearest-neighbor and linear interpolation. InterpolateOn() is equivalent to SetInterpolationModeToLinear() and InterpolateOff() is equivalent to SetInterpolationModeToNearestNeighbor(). You should not use these methods if you use the SetInterpolationMode methods. Definition at line 296 of file vtkImageReslice.h. References VTK_RESLICE_NEAREST.

void vtkImageReslice::SetStencil | ( | vtkImageStencilData * | stencil | ) |

| Use a stencil to limit the calculations to a specific region of the output. Portions of the output that are 'outside' the stencil will be cleared to the background color.

vtkImageStencilData* vtkImageReslice::GetStencil | ( |  | ) |

| Use a stencil to limit the calculations to a specific region of the output. Portions of the output that are 'outside' the stencil will be cleared to the background color.

void vtkImageReslice::GetAutoCroppedOutputBounds | ( | vtkImageData * | input,
|  | float | bounds[6]
| ) | `[protected]`

void vtkImageReslice::ExecuteInformation | ( | vtkImageData * | input,
|  | vtkImageData * | output
| ) | `[protected, virtual]`

| Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, and vtkImageResample.

void vtkImageReslice::ExecuteInformation | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkImageToImageFilter. Reimplemented in vtkImageFlip, and vtkImageResample.

void vtkImageReslice::ComputeInputUpdateExtents | ( | vtkDataObject * | output | ) | `[protected, virtual]`

| What is the input update extent that is required to produce the desired output? By default, the whole input is always required but this is overridden in many subclasses. Reimplemented from vtkImageToImageFilter.

void vtkImageReslice::ComputeInputUpdateExtent | ( | int | inExt[6],
|  | int | outExt[6]
| ) | `[protected, virtual]`

| Reimplemented from vtkImageToImageFilter.

void vtkImageReslice::ThreadedExecute | ( | vtkImageData * | inData,
|  | vtkImageData * | outData,
|  | int | ext[6],
|  | int | id
| ) | `[protected, virtual]`

| If the subclass does not define an Execute method, then the task will be broken up, multiple threads will be spawned, and each thread will call this method. It is public so that the thread functions can call this method. Reimplemented from vtkImageToImageFilter.

vtkMatrix4x4* vtkImageReslice::GetIndexMatrix | ( |  | ) | `[protected]`

vtkAbstractTransform* vtkImageReslice::GetOptimizedTransform | ( |  | ) | `[inline, protected]`

| Definition at line 341 of file vtkImageReslice.h.

void vtkImageReslice::OptimizedComputeInputUpdateExtent | ( | int | inExt[6],
|  | int | outExt[6]
| ) | `[protected]`

void vtkImageReslice::OptimizedThreadedExecute | ( | vtkImageData * | inData,
|  | vtkImageData * | outData,
|  | int | ext[6],
|  | int | id
| ) | `[protected]`

## Member Data Documentation

vtkMatrix4x4* vtkImageReslice::ResliceAxes`[protected]`

| Definition at line 312 of file vtkImageReslice.h.

double vtkImageReslice::ResliceAxesDirectionCosines[9]`[protected]`

| Definition at line 313 of file vtkImageReslice.h.

double vtkImageReslice::ResliceAxesOrigin[3]`[protected]`

| Definition at line 314 of file vtkImageReslice.h.

vtkAbstractTransform* vtkImageReslice::ResliceTransform`[protected]`

| Definition at line 315 of file vtkImageReslice.h.

vtkImageData* vtkImageReslice::InformationInput`[protected]`

| Definition at line 316 of file vtkImageReslice.h.

int vtkImageReslice::Wrap`[protected]`

| Definition at line 317 of file vtkImageReslice.h.

int vtkImageReslice::Mirror`[protected]`

| Definition at line 318 of file vtkImageReslice.h.

int vtkImageReslice::InterpolationMode`[protected]`

| Definition at line 319 of file vtkImageReslice.h. Referenced by GetInterpolationModeAsString().

int vtkImageReslice::Optimization`[protected]`

| Definition at line 320 of file vtkImageReslice.h.

float vtkImageReslice::BackgroundColor[4]`[protected]`

| Definition at line 321 of file vtkImageReslice.h.

float vtkImageReslice::OutputOrigin[3]`[protected]`

| Definition at line 322 of file vtkImageReslice.h.

float vtkImageReslice::OutputSpacing[3]`[protected]`

| Reimplemented in vtkImageResample. Definition at line 323 of file vtkImageReslice.h.

int vtkImageReslice::OutputExtent[6]`[protected]`

| Definition at line 324 of file vtkImageReslice.h.

int vtkImageReslice::OutputDimensionality`[protected]`

| Definition at line 325 of file vtkImageReslice.h.

int vtkImageReslice::TransformInputSampling`[protected]`

| Definition at line 326 of file vtkImageReslice.h.

int vtkImageReslice::AutoCropOutput`[protected]`

| Definition at line 327 of file vtkImageReslice.h.

vtkMatrix4x4* vtkImageReslice::IndexMatrix`[protected]`

| Definition at line 329 of file vtkImageReslice.h.

vtkAbstractTransform* vtkImageReslice::OptimizedTransform`[protected]`

| Definition at line 330 of file vtkImageReslice.h.

The documentation for this class was generated from the following file:

- Imaging/vtkImageReslice.h